/*
  TTF tHgʒuԂ
  Satofumi KAMIMURA
  $Id$
*/

#include "searchTTF.h"
#include "fileUtils.h"
#include <vector>
#include <cstring>

using namespace std;


std::string searchTTF(const char* fname)
{
  vector<string> try_files;
  try_files.push_back(fname);

  try_files.push_back("Vera.ttf");
  try_files.push_back("VL-Gothic-Regular.ttf");

  // Linux
  const char* linux_path[] ={
    "/usr/X11R6/lib/X11/fonts/TTF",
    "/usr/X11R6/lib/X11/fonts/TrueType",
    "/usr/share/fonts/ja/TrueType",
    "/usr/share/fonts/japanese/TrueType",
    "/var/lib/defoma/gs.d/dirs/fonts",

    "/usr/share/fonts/truetype",                        // Ubuntu 9.04
    "/usr/lib/python2.6/site-packages/reportlab/fonts", // Fedora 11

    "/usr/share/fonts/vlgothic",           // Ubuntu 9.04, Fedora 12
    "/usr/share/fonts/truetype/vlgothic",  // Ubuntu 9.10, Fedora 11

    NULL,
  };

  size_t n = try_files.size();
  for (size_t i = 0; i < n; ++i) {
    string ttf_path = VXV::searchFile(try_files[i].c_str(), linux_path);
    if (!ttf_path.empty()) {
      return ttf_path;
    }
  }

  // Windows
  const char* windows_path[] = {
    "C://WINDOWS/Fonts",
    NULL,
  };
  string ttf_path = VXV::searchFile("times.ttf", windows_path);
  if (!ttf_path.empty()) {
    return ttf_path;
  }

  return "";
}
